Distinguish indets from symbols in coeffring in Use command
Status: Rejected Start date: 23 Oct 2014

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: enhancing/improving Estimated time: 0.66 hour

Target version: CoCoA-5.4.0 Spent time: 0.65 hour

Description

The use command assigns the top-level variables whose names match those of the symbols in the ring.  The assigned values are

the values of the symbols in the given ring.

Suggestion: if the ring is a polynomial ring then the indeterminates are assigned as they are now, while all other symbols are

assigned as elements of the coeffring.  This is reasonable only if we already have automatic mapping of ringelems.

Discuss!

Related issues:

Related to CoCoA-5 - Feature #7: Automatic mapping between (some) rings Resolved 20 Oct 2011

Related to CoCoA-5 - Design #635: Automatic mapping of RingElem (in operation... Closed 22 Oct 2014

Related to CoCoA-5 - Design #634: Symbol in the coeff ring Rejected 22 Oct 2014

Related to CoCoA-5 - Design #637: Undesirable consequence of automatic mappin... Closed 23 Oct 2014

Related to CoCoALib - Design #1515: Indets in coeffring are ringelems in coef... Rejected 22 Oct 2020

History

#1 - 23 Oct 2014 22:05 - John Abbott

Consider the following scenario:

QQa ::= QQ[a];

P ::= QQa[x];

Use P;

deg(a); // will give 1

a2 := (x+a)-x;

a = a2; // true or false or error?

deg(a2); // must surely give 0, right?

Should a and a2 be considered as equal/equivalent in all contexts?

#2 - 11 May 2015 14:49 - John Abbott

- Target version changed from CoCoA-5.1.2 summer 2015 to CoCoA-5.1.3/4 Jan 2016

#3 - 17 Feb 2016 13:22 - John Abbott

- Target version changed from CoCoA-5.1.3/4 Jan 2016 to CoCoA-5.?.?

I'm delaying this issue until some unspecified time in the future because it looks to be tricky to resolve.
The point is that in a ring such as QQ[a][x] CoCoA sees everything as a polynomial in just x, so a call such as deg(a^2,a) is seen as deg(coeff,coeff)

which makes no sense (and so will produce an error).  However an "advanced user" who understands this will have difficulty in effecting the desired

computation...

The following will perform the desired computation

deg(LC(a^2), LC(a));

but it is not so clear to the reader what such a call should do.  I would like to have something which makes it clear to the reader what the computation

is... but how to achieve this?    

The solution should work well regardless of the nesting depth of the rings: think of QQ[a][b][c][x,y,z] for instance.

#4 - 22 Oct 2020 17:31 - John Abbott

- Related to Design #1515: Indets in coeffring are ringelems in coeffring? added

#5 - 27 Oct 2020 17:59 - John Abbott

- Status changed from New to Rejected

- Assignee set to John Abbott

- Target version changed from CoCoA-5.?.? to CoCoA-5.4.0

- % Done changed from 0 to 100

- Estimated time set to 0.66 h

I am rejecting this.  This issue is essentially duplicated in #1515.

Main reason for rejection is in comment 3 of issue #1515

Namely, too hard to interpret a "cleverly" in the ring QQ(a)[x] where 1/a must be allowed.
